
    create table identity_obj_properties (
        IDENTITY_OBJ_ID bigint not null,
        PROPERTY varchar(255),
        prop_key varchar(255) not null,
        primary key (IDENTITY_OBJ_ID, prop_key)
    ) type=InnoDB;

    create table jbid_io (
        id bigint not null auto_increment,
        NAME varchar(255) not null,
        IDENTITY_TYPE bigint not null,
        REALM bigint not null,
        primary key (id),
        unique (NAME, IDENTITY_TYPE, REALM)
    ) type=InnoDB;

    create table jbid_io_attr (
        ATTRIBUTE_ID bigint not null auto_increment,
        NAME varchar(255),
        IDENTITY_OBJECT_ID bigint not null,
        primary key (ATTRIBUTE_ID),
        unique (NAME, IDENTITY_OBJECT_ID)
    ) type=InnoDB;

    create table jbid_io_attr_bin (
        ATTRIBUTE_ID bigint not null,
        primary key (ATTRIBUTE_ID)
    ) type=InnoDB;

    create table jbid_io_attr_bin_jbid_io_bin (
        jbid_io_attr_bin_ATTRIBUTE_ID bigint not null,
        values_id bigint not null,
        primary key (jbid_io_attr_bin_ATTRIBUTE_ID, values_id),
        unique (values_id)
    ) type=InnoDB;

    create table jbid_io_attr_text (
        ATTRIBUTE_ID bigint not null,
        primary key (ATTRIBUTE_ID)
    ) type=InnoDB;

    create table jbid_io_attr_text_values (
        jbid_io_attr_text_ATTRIBUTE_ID bigint not null,
        element varchar(255)
    ) type=InnoDB;

    create table jbid_io_bin (
        id bigint not null auto_increment,
        value longblob,
        primary key (id)
    ) type=InnoDB;

    create table jbid_io_creden (
        id bigint not null auto_increment,
        BINARY_VALUE longblob,
        TEXT varchar(255),
        IDENTITY_OBJECT_ID bigint not null,
        CREDENTIAL_TYPE bigint not null,
        primary key (id),
        unique (CREDENTIAL_TYPE, IDENTITY_OBJECT_ID)
    ) type=InnoDB;

    create table jbid_io_creden_props (
        CREDENTIAL_ID bigint not null,
        PROPERTY varchar(255),
        prop_key varchar(255) not null,
        primary key (CREDENTIAL_ID, prop_key)
    ) type=InnoDB;

    create table jbid_io_creden_type (
        id bigint not null auto_increment,
        NAME varchar(255) unique,
        primary key (id)
    ) type=InnoDB;

    create table jbid_io_realm_props (
        REALM_ID bigint not null,
        PROPERTY varchar(255),
        prop_key varchar(255) not null,
        primary key (REALM_ID, prop_key)
    ) type=InnoDB;

    create table jbid_io_rel (
        id bigint not null auto_increment,
        FROM_IDENTITY bigint not null,
        NAME bigint,
        TO_IDENTITY bigint not null,
        TYPE bigint not null,
        primary key (id),
        unique (NAME, TYPE, FROM_IDENTITY, TO_IDENTITY)
    ) type=InnoDB;

    create table jbid_io_rel_name (
        id bigint not null auto_increment,
        NAME varchar(255) not null unique,
        REALM bigint not null,
        primary key (id),
        unique (NAME, REALM)
    ) type=InnoDB;

    create table jbid_io_rel_name_props (
        REALATIONSHIP_NAME_ID bigint not null,
        PROPERTY varchar(255),
        prop_key varchar(255) not null,
        primary key (REALATIONSHIP_NAME_ID, prop_key)
    ) type=InnoDB;

    create table jbid_io_rel_props (
        REALATIONSHIP_ID bigint not null,
        PROPERTY varchar(255),
        prop_key varchar(255) not null,
        primary key (REALATIONSHIP_ID, prop_key)
    ) type=InnoDB;

    create table jbid_io_rel_type (
        id bigint not null auto_increment,
        name varchar(255) not null unique,
        primary key (id)
    ) type=InnoDB;

    create table jbid_io_type (
        id bigint not null auto_increment,
        name varchar(255) not null unique,
        primary key (id)
    ) type=InnoDB;

    create table jbid_realm (
        id bigint not null auto_increment,
        NAME varchar(255) not null,
        primary key (id),
        unique (NAME)
    ) type=InnoDB;

    alter table identity_obj_properties 
        add index FK4565EF1C7FD4BF0F (IDENTITY_OBJ_ID), 
        add constraint FK4565EF1C7FD4BF0F 
        foreign key (IDENTITY_OBJ_ID) 
        references jbid_io (id);

    alter table jbid_io 
        add index FK94860092842CE3F0 (REALM), 
        add constraint FK94860092842CE3F0 
        foreign key (REALM) 
        references jbid_realm (id);

    alter table jbid_io 
        add index FK94860092DA527B00 (IDENTITY_TYPE), 
        add constraint FK94860092DA527B00 
        foreign key (IDENTITY_TYPE) 
        references jbid_io_type (id);

    alter table jbid_io_attr 
        add index FK4DC61D7EBFDBFEE5 (IDENTITY_OBJECT_ID), 
        add constraint FK4DC61D7EBFDBFEE5 
        foreign key (IDENTITY_OBJECT_ID) 
        references jbid_io (id);

    alter table jbid_io_attr_bin 
        add index FK9A8BDAC6D110A16F (ATTRIBUTE_ID), 
        add constraint FK9A8BDAC6D110A16F 
        foreign key (ATTRIBUTE_ID) 
        references jbid_io_attr (ATTRIBUTE_ID);

    alter table jbid_io_attr_bin_jbid_io_bin 
        add index FKF39453E1249F3B99 (values_id), 
        add constraint FKF39453E1249F3B99 
        foreign key (values_id) 
        references jbid_io_bin (id);

    alter table jbid_io_attr_bin_jbid_io_bin 
        add index FKF39453E11745EB87 (jbid_io_attr_bin_ATTRIBUTE_ID), 
        add constraint FKF39453E11745EB87 
        foreign key (jbid_io_attr_bin_ATTRIBUTE_ID) 
        references jbid_io_attr_bin (ATTRIBUTE_ID);

    alter table jbid_io_attr_text 
        add index FKB6F79F4ED110A16F (ATTRIBUTE_ID), 
        add constraint FKB6F79F4ED110A16F 
        foreign key (ATTRIBUTE_ID) 
        references jbid_io_attr (ATTRIBUTE_ID);

    alter table jbid_io_attr_text_values 
        add index FKC6F8C7336D68F593 (jbid_io_attr_text_ATTRIBUTE_ID), 
        add constraint FKC6F8C7336D68F593 
        foreign key (jbid_io_attr_text_ATTRIBUTE_ID) 
        references jbid_io_attr_text (ATTRIBUTE_ID);

    alter table jbid_io_creden 
        add index FKF7FB3EC44EF15A3E (CREDENTIAL_TYPE), 
        add constraint FKF7FB3EC44EF15A3E 
        foreign key (CREDENTIAL_TYPE) 
        references jbid_io_creden_type (id);

    alter table jbid_io_creden 
        add index FKF7FB3EC4BFDBFEE5 (IDENTITY_OBJECT_ID), 
        add constraint FKF7FB3EC4BFDBFEE5 
        foreign key (IDENTITY_OBJECT_ID) 
        references jbid_io (id);

    alter table jbid_io_creden_props 
        add index FKBAD64835DF01FC5 (CREDENTIAL_ID), 
        add constraint FKBAD64835DF01FC5 
        foreign key (CREDENTIAL_ID) 
        references jbid_io_creden (id);

    alter table jbid_io_realm_props 
        add index FKBB6DB3934A7D622C (REALM_ID), 
        add constraint FKBB6DB3934A7D622C 
        foreign key (REALM_ID) 
        references jbid_realm (id);

    alter table jbid_io_rel 
        add index FKE9BC4F6CD5BB51F7 (TYPE), 
        add constraint FKE9BC4F6CD5BB51F7 
        foreign key (TYPE) 
        references jbid_io_rel_type (id);

    alter table jbid_io_rel 
        add index FKE9BC4F6CD5B52899 (NAME), 
        add constraint FKE9BC4F6CD5B52899 
        foreign key (NAME) 
        references jbid_io_rel_name (id);

    alter table jbid_io_rel 
        add index FKE9BC4F6CB097E0BE (FROM_IDENTITY), 
        add constraint FKE9BC4F6CB097E0BE 
        foreign key (FROM_IDENTITY) 
        references jbid_io (id);

    alter table jbid_io_rel 
        add index FKE9BC4F6CC52050D (TO_IDENTITY), 
        add constraint FKE9BC4F6CC52050D 
        foreign key (TO_IDENTITY) 
        references jbid_io (id);

    alter table jbid_io_rel_name 
        add index FK5856A77E842CE3F0 (REALM), 
        add constraint FK5856A77E842CE3F0 
        foreign key (REALM) 
        references jbid_realm (id);

    alter table jbid_io_rel_name_props 
        add index FK224ABD6FB176E3F1 (REALATIONSHIP_NAME_ID), 
        add constraint FK224ABD6FB176E3F1 
        foreign key (REALATIONSHIP_NAME_ID) 
        references jbid_io_rel_name (id);

    alter table jbid_io_rel_props 
        add index FKB2A23ADD8A45DAEA (REALATIONSHIP_ID), 
        add constraint FKB2A23ADD8A45DAEA 
        foreign key (REALATIONSHIP_ID) 
        references jbid_io_rel (id);
